import { world, system, BlockPermutation, Dimension } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  const oldBlockNames = [
    "nicothekid:blooming_corrupted_oak_sapling_block",
    "nicothekid:corrupted_oak_sapling_block",
    "nicothekid:corrupted_grass_block",
    "nicothekid:hanging_moss_block",
    "nicothekid:short_moss_sprouts_block",
    "nicothekid:tall_moss_sprouts_block"
  ]
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:block_updating_mb_on_tick", {
    onTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      const blockState = block.permutation.getState("minecraft:cardinal_direction");
      const blockAllState = block.permutation.getAllStates();
      if (oldBlockNames.includes(block.typeId)) {
        if (block.permutation.matches("nicothekid:blooming_corrupted_oak_sapling_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:blooming_corrupted_oak_sapling"));
          return;
        }
        if (block.permutation.matches("nicothekid:corrupted_oak_sapling_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:corrupted_oak_sapling"));
          return;
        }
        if (block.permutation.matches("nicothekid:corrupted_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:corrupted_grass"));
          return;
        }
        if (block.permutation.matches("nicothekid:hanging_moss_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:hanging_moss"));
          return;
        }
        if (block.permutation.matches("nicothekid:short_moss_sprouts_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:short_moss_sprouts"));
          return;
        }
        if (block.permutation.matches("nicothekid:tall_moss_sprouts_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:tall_moss_sprouts"));
          return;
        }
      }
      else return;
    }
  });
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:block_updating_mb_on_random_tick", {
    onRandomTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      const blockState = block.permutation.getState("minecraft:cardinal_direction");
      const blockAllState = block.permutation.getAllStates();
      if (oldBlockNames.includes(block.typeId)) {
        if (block.permutation.matches("nicothekid:blooming_corrupted_oak_sapling_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:blooming_corrupted_oak_sapling"));
          return;
        }
        if (block.permutation.matches("nicothekid:corrupted_oak_sapling_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:corrupted_oak_sapling"));
          return;
        }
        if (block.permutation.matches("nicothekid:corrupted_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:corrupted_grass"));
          return;
        }
        if (block.permutation.matches("nicothekid:hanging_moss_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:hanging_moss"));
          return;
        }
        if (block.permutation.matches("nicothekid:short_moss_sprouts_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:short_moss_sprouts"));
          return;
        }
        if (block.permutation.matches("nicothekid:tall_moss_sprouts_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:tall_moss_sprouts"));
          return;
        }
      }
      else return;
    }
  });
});