import { world, system, BlockPermutation, ItemStack, GameMode } from "@minecraft/server";

world.afterEvents.playerBreakBlock.subscribe(eventData => {
  const player = eventData.player;
  const itemUsed = eventData.itemStackBeforeBreak;
  const brokenBlock = eventData.brokenBlockPermutation;
  const block = eventData.block;
  const blockLocation = block.location;
  const customMinerals = [
    "nicothekid:fossiliferous_corrupted_dirt",
    "nicothekid:fossiliferous_corrupted_stone"
  ]
  function spawnXpOrb () {
    const silkTouchEnchanted = itemUsed.getComponent("enchantable").getEnchantment("silk_touch");
    if (!silkTouchEnchanted) {
      block.dimension.spawnEntity("minecraft:xp_orb", { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
    }
  }
  function spawnBone () {
    const fortuneEnchanted = itemUsed.getComponent("enchantable").getEnchantment("fortune");
    if (itemUsed.getComponent("enchantable").hasEnchantment("fortune")) {
      if (fortuneEnchanted.level == 1) {
        let fortuneChance = Math.random() * (2 - 1) + 1;
        const itemBone = new ItemStack ("minecraft:bone", fortuneChance);
        block.dimension.spawnItem(itemBone, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
      }
      if (fortuneEnchanted.level == 2) {
        let fortuneChance = Math.random() * (3 - 1) + 1;
        const itemBone = new ItemStack ("minecraft:bone", fortuneChance);
        block.dimension.spawnItem(itemBone, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
      }
      if (fortuneEnchanted.level == 3) {
        let fortuneChance = Math.random() * (3 - 2) + 2;
        const itemBone = new ItemStack ("minecraft:bone", fortuneChance);
        block.dimension.spawnItem(itemBone, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
      }
    }
    else {
      const itemBone = new ItemStack ("minecraft:bone", 1);
      block.dimension.spawnItem(itemBone, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
    }
  }
  if (itemUsed === undefined || player.matches({ gameMode: GameMode.creative })) return;
  if (customMinerals.includes(brokenBlock.type.id)) {
    const itemEnchantable = itemUsed.getComponent("enchantable");
    if (!itemEnchantable) return;
    const silkTouchEnchanted = itemEnchantable.getEnchantment("silk_touch");
    const fortuneEnchanted = itemEnchantable.getEnchantment("fortune");
    if (silkTouchEnchanted) return;
    if (itemUsed.hasTag("minecraft:is_pickaxe")) {
      if (brokenBlock.type.id === "nicothekid:fossiliferous_corrupted_stone") {
        spawnBone ();
        spawnXpOrb ();
      }
    }
    if (itemUsed.hasTag("minecraft:is_shovel")) {
      if (brokenBlock.type.id === "nicothekid:fossiliferous_corrupted_dirt") {
        spawnBone ();
        spawnXpOrb ();
      }
    }
  }
  else return;
});
