import { world, BlockPermutation, ItemStack, GameMode } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:hanging_moss_on_player_destroy", {
    onPlayerDestroy: eventData => {
      const player = eventData.player;
      const destroyedBlock = eventData.destroyedBlockPermutation;
      const block = eventData.block;
      const blockLocation = block.location;
      const playerEquippable = player.getComponent("equippable");
      const itemUsed = playerEquippable.getEquipment("Mainhand");
      if (player.matches({ gameMode: GameMode.creative })) return;
      if (destroyedBlock.type.id === "nicothekid:hanging_moss") {
        if (itemUsed === undefined) {
          return;
        }
        else {
          if (itemUsed.typeId === "minecraft:shears") {
            const spawnPlant = new ItemStack ("nicothekid:hanging_moss", 1);
            block.dimension.spawnItem(spawnPlant, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
          }
          else return;
        }
      }
      else return;
    }
  });
})
