import { world, system, BlockPermutation, Dimension, ItemStack, GameMode } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:mossy_willow_sapling_growth", {
    onPlayerInteract: eventData => {
      const player = eventData.player;
      const block = eventData.block;
      const blockLocation = block.location;
      const playerEquippable = player.getComponent("equippable");
      const itemUsed = playerEquippable.getEquipment("Mainhand");
      function decreaseItem () {
        if (!player.matches({ gameMode: GameMode.creative })) {
          const decrementItem = itemUsed.amount == 1 ? undefined : (itemUsed.amount--, itemUsed);
          playerEquippable.setEquipment("Mainhand", decrementItem)
        }
      }
      if (itemUsed === undefined) return;
      if (block.typeId === "nicothekid:mossy_willow_sapling" && itemUsed.typeId === "minecraft:bone_meal") {
        system.run(() => {
          let randomChance = Math.random() * 100.0;
          decreaseItem ();
          block.dimension.playSound("item.bone_meal.use", blockLocation, { pitch: 1.0, volume: 1.0 });
          block.dimension.spawnParticle("minecraft:crop_growth_emitter", { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
          if (randomChance <= 40.0) {
            let randomVariation = Math.random() * 100.0;
            if (randomVariation <= 20.0) {
              block.setPermutation(BlockPermutation.resolve("minecraft:air"));
              block.dimension.runCommandAsync(`structure load "mb/mossy_willow_tree_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomVariation <= 40.0) {
              block.setPermutation(BlockPermutation.resolve("minecraft:air"));
              block.dimension.runCommandAsync(`structure load "mb/mossy_willow_tree_02" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomVariation <= 60.0) {
              block.setPermutation(BlockPermutation.resolve("minecraft:air"));
              block.dimension.runCommandAsync(`structure load "mb/mossy_willow_tree_03" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomVariation <= 80.0) {
              block.setPermutation(BlockPermutation.resolve("minecraft:air"));
              block.dimension.runCommandAsync(`structure load "mb/mossy_willow_tree_04" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomVariation <= 100.0) {
              block.setPermutation(BlockPermutation.resolve("minecraft:air"));
              block.dimension.runCommandAsync(`structure load "mb/mossy_willow_tree_05" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else return;
          }
          else return;
        });
      }
      else return;
    }
  });
});

world.beforeEvents.itemUseOn.subscribe(eventData => {
  const player = eventData.source;
  const itemUsed = eventData.itemStack;
  const block = eventData.block;
  const playerEquippable = player.getComponent("equippable");
  function decreaseItem () {
    system.run(() => {
      if (!player.matches({ gameMode: GameMode.creative })) {
        const decrementItem = itemUsed.amount == 1 ? undefined : (itemUsed.amount--, itemUsed);
        playerEquippable.setEquipment("Mainhand", decrementItem)
      }
    });
  }
  if (itemUsed === undefined || player.isSneaking) return;
  if (itemUsed.typeId === "nicothekid:mossy_willow_sapling" && block.typeId === "minecraft:flower_pot") {
    system.run(() => {
      decreaseItem ();
      block.setPermutation(BlockPermutation.resolve("nicothekid:potted_mossy_willow_sapling"));
    });
  }
  else return;
});
