import { world, BlockPermutation, ItemStack, GameMode } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:overgrown_jungle_leaves_on_player_destroy", {
    onPlayerDestroy: eventData => {
      const player = eventData.player;
      const destroyedBlock = eventData.destroyedBlockPermutation;
      const block = eventData.block;
      const blockLocation = block.location;
      const playerEquippable = player.getComponent("equippable");
      const itemUsed = playerEquippable.getEquipment("Mainhand");
      let randomChance = Math.random() * 100.0;
      if (player.matches({ gameMode: GameMode.creative })) return;
      if (destroyedBlock.type.id === "nicothekid:overgrown_jungle_leaves") {
        if (itemUsed === undefined) {
          if (randomChance <= 5.0) {
            const spawnSapling = new ItemStack ("nicothekid:overgrown_jungle_sapling", 1);
            block.dimension.spawnItem(spawnSapling, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
          }
          else if (randomChance <= 7.0) {
            const spawnStick = new ItemStack ("minecraft:stick", 1);
            block.dimension.spawnItem(spawnStick, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
          }
          else return;
        }
        else {
          if (itemUsed.typeId === "minecraft:shears") {
            const spawnLeaves = new ItemStack ("nicothekid:overgrown_jungle_leaves", 1);
            block.dimension.spawnItem(spawnLeaves, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
          }
          else {
            const itemEnchantable = itemUsed.getComponent("enchantable");
            if (itemEnchantable) {
              const silkTouchEnchanted = itemEnchantable.getEnchantment("silk_touch");
              if (silkTouchEnchanted) return;
              const fortuneEnchanted = itemUsed.getComponent("enchantable").getEnchantment("fortune");
              if (itemUsed.getComponent("enchantable").hasEnchantment("fortune")) {
                if (fortuneEnchanted.level == 1) {
                  if (randomChance <= 8.0) {
                    const spawnSapling = new ItemStack ("nicothekid:overgrown_jungle_sapling", 1);
                    block.dimension.spawnItem(spawnSapling, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
                  }
                  else if (randomChance <= 10.0) {
                    const spawnStick = new ItemStack ("minecraft:stick", 1);
                    block.dimension.spawnItem(spawnStick, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
                  }
                  else return;
                }
                if (fortuneEnchanted.level == 2) {
                  if (randomChance <= 10.0) {
                    const spawnSapling = new ItemStack ("nicothekid:overgrown_jungle_sapling", 1);
                    block.dimension.spawnItem(spawnSapling, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
                  }
                  else if (randomChance <= 13.0) {
                    const spawnStick = new ItemStack ("minecraft:stick", 1);
                    block.dimension.spawnItem(spawnStick, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
                  }
                  else return;
                }
                if (fortuneEnchanted.level == 3) {
                  if (randomChance <= 13.0) {
                    const spawnSapling = new ItemStack ("nicothekid:overgrown_jungle_sapling", 1);
                    block.dimension.spawnItem(spawnSapling, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
                  }
                  else if (randomChance <= 15.0) {
                    const spawnStick = new ItemStack ("minecraft:stick", 1);
                    block.dimension.spawnItem(spawnStick, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
                  }
                  else return;
                }
              }
              else {
                if (randomChance <= 5.0) {
                  const spawnSapling = new ItemStack ("nicothekid:overgrown_jungle_sapling", 1);
                  block.dimension.spawnItem(spawnSapling, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
                }
                else if (randomChance <= 7.0) {
                  const spawnStick = new ItemStack ("minecraft:stick", 1);
                  block.dimension.spawnItem(spawnStick, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
                }
                else return;
              }
            }
            else {
              if (randomChance <= 5.0) {
                const spawnSapling = new ItemStack ("nicothekid:overgrown_jungle_sapling", 1);
                block.dimension.spawnItem(spawnSapling, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
              }
              else if (randomChance <= 7.0) {
                const spawnStick = new ItemStack ("minecraft:stick", 1);
                block.dimension.spawnItem(spawnStick, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
              }
              else return;
            }
          }
        }
      }
      else return;
    }
  });
})
/*
world.beforeEvents.worldInitialize.subscribe(initEvent => {
  const validLogs = [
    "nicothekid:overgrown_jungle_log",
    "nicothekid:overgrown_jungle_wood",
    "nicothekid:grassed_overgrown_jungle_log_side",
    "nicothekid:grassed_overgrown_jungle_log_top",
    "nicothekid:mossed_overgrown_jungle_log_side",
    "nicothekid:mossed_overgrown_jungle_log_top"
  ];
  function detectNearbyLogs(block, dimension, radius) {
    for (let dx = -radius; dx <= radius; dx++) {
      for (let dy = -radius; dy <= radius; dy++) {
        for (let dz = -radius; dz <= radius; dz++) {
          const areaLocation = {
            x: block.location.x + dx,
            y: block.location.y + dy,
            z: block.location.z + dz
          };
          const areaBlock = dimension.getBlock(areaLocation)
          if (areaBlock === undefined) {
            return false;
          }
          else {
            if (validLogs.includes(areaBlock.type.id)) {
              return true;
            }
          }
        }
      }
    }
    return false;
  }
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:overgrown_jungle_leaves_on_random_tick", {
    onRandomTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      const dimension = eventData.dimension;
      if (block.permutation.matches("nicothekid:overgrown_jungle_leaves", {"nicothekid:persistent_bit": false})) {
        if (detectNearbyLogs(block, dimension, 6) === true) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:overgrown_jungle_leaves", {"nicothekid:persistent_bit": true}));
        }
        else return;
      }
      else if (block.permutation.matches("nicothekid:overgrown_jungle_leaves", {"nicothekid:persistent_bit": true})) {
        if (detectNearbyLogs(block, dimension, 6) === false) {
          let randomChance = Math.random() * 100.0;
          block.setPermutation(BlockPermutation.resolve("minecraft:air"));
          if (randomChance <= 5.0) {
            const spawnSapling = new ItemStack ("nicothekid:overgrown_jungle_sapling", 1);
            block.dimension.spawnItem(spawnSapling, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
          }
          else if (randomChance <= 7.0) {
            const spawnStick = new ItemStack ("minecraft:stick", 1);
            block.dimension.spawnItem(spawnStick, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
          }
          else return;
        }
        else return;
      }
      else return;
    }
  });
})
*/