import { world, system, BlockPermutation, GameMode } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  const potableItems = [
    "minecraft:short_grass",
    "minecraft:fern",
    "minecraft:allium",
    "minecraft:azure_bluet",
    "minecraft:blue_orchid",
    "minecraft:cornflower",
    "minecraft:dandelion",
    "minecraft:lily_of_the_valley",
    "minecraft:oxeye_daisy",
    "minecraft:poppy",
    "minecraft:orange_tulip",
    "minecraft:pink_tulip",
    "minecraft:red_tulip",
    "minecraft:white_tulip",
    "minecraft:wither_rose",
    "minecraft:torchflower",
    "minecraft:oak_sapling",
    "minecraft:spruce_sapling",
    "minecraft:birch_sapling",
    "minecraft:jungle_sapling",
    "minecraft:acacia_sapling",
    "minecraft:dark_oak_sapling",
    "minecraft:mangrove_propagule",
    "minecraft:cherry_sapling",
    "minecraft:azalea",
    "minecraft:flowering_azalea",
    "minecraft:brown_mushroom",
    "minecraft:red_mushroom",
    "minecraft:crimson_fungus",
    "minecraft:warped_fungus",
    "minecraft:crimson_roots",
    "minecraft:warped_roots",
    "minecraft:bamboo",
    "minecraft:cactus",
    "minecraft:deadbush",
    "minecraft:pale_oak_sapling",
    "minecraft:closed_eyeblossom",
    "minecraft:open_eyeblossom",
    "nicothekid:blooming_corrupted_oak_sapling",
    "nicothekid:blue_tip_grass",
    "nicothekid:corrupted_grass",
    "nicothekid:corrupted_oak_sapling",
    "nicothekid:hanging_moss",
    "nicothekid:light_blue_tip_grass",
    "nicothekid:magenta_tip_grass",
    "nicothekid:mosshroom_fungus",
    "nicothekid:mossy_willow_sapling",
    "nicothekid:mycelium_sprouts_tall",
    "nicothekid:orange_tip_grass",
    "nicothekid:overgrown_jungle_sapling",
    "nicothekid:pink_tip_grass",
    "nicothekid:red_tip_grass",
    "nicothekid:tall_glowcelium_sprouts",
    "nicothekid:tall_moss_sprouts",
    "nicothekid:tall_mycelium_sprouts",
    "nicothekid:tall_lush_grass",
    "nicothekid:white_tip_grass",
    "nicothekid:yellow_tip_grass"
  ]
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:mb_potted_plants_on_player_interact", {
    onPlayerInteract: eventData => {
      const player = eventData.player;
      const block = eventData.block;
      const blockLocation = block.location;
      const playerEquippable = player.getComponent("equippable");
      const itemUsed = playerEquippable.getEquipment("Mainhand");
      if (itemUsed === undefined || !potableItems.includes(itemUsed.typeId)) {
        if (block.permutation.matches("nicothekid:potted_blooming_corrupted_oak_sapling")) {
          player.runCommandAsync(`gamerule sendcommandfeedback false`);
          player.runCommandAsync(`give @s nicothekid:blooming_corrupted_oak_sapling 1`);
          player.runCommandAsync(`gamerule sendcommandfeedback true`);
          block.setPermutation(BlockPermutation.resolve("minecraft:flower_pot"));
          return;
        }
        if (block.permutation.matches("nicothekid:potted_corrupted_grass")) {
          player.runCommandAsync(`gamerule sendcommandfeedback false`);
          player.runCommandAsync(`give @s nicothekid:corrupted_grass 1`);
          player.runCommandAsync(`gamerule sendcommandfeedback true`);
          block.setPermutation(BlockPermutation.resolve("minecraft:flower_pot"));
          return;
        }
        if (block.permutation.matches("nicothekid:potted_corrupted_oak_sapling")) {
          player.runCommandAsync(`gamerule sendcommandfeedback false`);
          player.runCommandAsync(`give @s nicothekid:corrupted_oak_sapling 1`);
          player.runCommandAsync(`gamerule sendcommandfeedback true`);
          block.setPermutation(BlockPermutation.resolve("minecraft:flower_pot"));
          return;
        }
        if (block.permutation.matches("nicothekid:potted_hanging_moss")) {
          player.runCommandAsync(`gamerule sendcommandfeedback false`);
          player.runCommandAsync(`give @s nicothekid:hanging_moss 1`);
          player.runCommandAsync(`gamerule sendcommandfeedback true`);
          block.setPermutation(BlockPermutation.resolve("minecraft:flower_pot"));
          return;
        }
        if (block.permutation.matches("nicothekid:potted_moss_sprouts")) {
          player.runCommandAsync(`gamerule sendcommandfeedback false`);
          player.runCommandAsync(`give @s nicothekid:tall_moss_sprouts 1`);
          player.runCommandAsync(`gamerule sendcommandfeedback true`);
          block.setPermutation(BlockPermutation.resolve("minecraft:flower_pot"));
          return;
        }
        if (block.permutation.matches("nicothekid:potted_mossy_willow_sapling")) {
          player.runCommandAsync(`gamerule sendcommandfeedback false`);
          player.runCommandAsync(`give @s nicothekid:mossy_willow_sapling 1`);
          player.runCommandAsync(`gamerule sendcommandfeedback true`);
          block.setPermutation(BlockPermutation.resolve("minecraft:flower_pot"));
          return;
        }
        if (block.permutation.matches("nicothekid:potted_overgrown_jungle_sapling")) {
          player.runCommandAsync(`gamerule sendcommandfeedback false`);
          player.runCommandAsync(`give @s nicothekid:overgrown_jungle_sapling 1`);
          player.runCommandAsync(`gamerule sendcommandfeedback true`);
          block.setPermutation(BlockPermutation.resolve("minecraft:flower_pot"));
          return;
        }
      }
      else return;
    }
  });
});
