import { world, system, BlockPermutation, Dimension, ItemStack, GameMode } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent("nicothekid:tall_moss_sprouts_on_use_on", {
    onUseOn: eventData => {
      const player = eventData.source;
      const itemUsed = eventData.itemStack;
      const block = eventData.block;
      const playerEquippable = player.getComponent("equippable");
      function decreaseItem () {
        system.run(() => {
          if (!player.matches({ gameMode: GameMode.creative })) {
            const decrementItem = itemUsed.amount == 1 ? undefined : (itemUsed.amount--, itemUsed);
            playerEquippable.setEquipment("Mainhand", decrementItem)
          }
        });
      }
      if (player.isSneaking) return;
      if (itemUsed.typeId === "nicothekid:tall_moss_sprouts") {
        system.run(() => {
          if (block.typeId === "minecraft:flower_pot") {
            decreaseItem ();
            block.setPermutation(BlockPermutation.resolve("nicothekid:potted_moss_sprouts"));
          }
        });
      }
    }
  });
});